#!/bin/bash
# {{ ansible_managed }}
#
# Create a new dump of the current elasticsearch data and provide it via the nginx
#

RESOURCE_URL_BASEPATH={{ search_index_public_base_url }}{{ search_index_public_base_path }}
WORK_DIR={{ base_dir }}/.dump
TARGET_DIR={{ search_index_dumps_instdir }}
TIMESTAMP=`date +"%Y-%m-%d"`
ID_DUMP_FILE="${WORK_DIR}/{{ elasticsearch_metadata_index_alias_name }}_IDs.${TIMESTAMP}"
DUMP_FILE="${WORK_DIR}/{{ elasticsearch_metadata_index_alias_name }}.ndjson"

date +"*** %Y-%m-%d %H:%M:%S Starting dump creation in $WORK_DIR"
mkdir -p $WORK_DIR

PIT_ID=$(curl --netrc-file {{ base_dir }}/conf/search_index_elastic_access -X POST "http://{{ elasticsearch_host }}:{{ elasticsearch_port }}/{{ elasticsearch_metadata_index_alias_name }}/_pit?keep_alive=1m" | jq -r '.id')
date +"*** %Y-%m-%d %H:%M:%S PIT $PIT_ID"

> $ID_DUMP_FILE
> $DUMP_FILE
i=0
LAST_SORT=
while true ; do
  i=$((i+1))
  CRITERIA="{\"size\": 5000, \"track_total_hits\": false, \"_source\": true, \"pit\":{\"id\":\"$PIT_ID\", \"keep_alive\":\"1m\"}, \"sort\": [{\"id\":\"asc\"}]}"
  if [ ! -z "$LAST_SORT" ]; then
    CRITERIA=$(echo $CRITERIA | jq ".search_after += $LAST_SORT")
  fi
  date +"*** %Y-%m-%d %H:%M:%S fetching next data"
  HITS=$(curl --netrc-file {{ base_dir }}/conf/search_index_elastic_access -X GET --header 'Content-Type: application/json' "http://{{ elasticsearch_host }}:{{ elasticsearch_port }}/_search" -d "$CRITERIA" | jq '.hits .hits | select(length > 0)')
  if [ $? -ne 0 ] || [ -z "$HITS" ]; then
    break
  fi
  
  date +"*** %Y-%m-%d %H:%M:%S writing next data to file"
  echo $HITS | jq -c -r '.[] | "\(._source.{{ search_index_metadata_field_configuration.resource_identifier }})	\(._id)"' >> $ID_DUMP_FILE
  echo $HITS | jq -c '.[] ._source' >> $DUMP_FILE

  LAST_SORT=$(echo $HITS | jq -r '.[-1] .sort')
  if [ -z "$LAST_SORT" ]; then
    date +"*** %Y-%m-%d %H:%M:%S Could not find last sort attr"
    break
  fi
done

date +"*** %Y-%m-%d %H:%M:%S removing pit $PIT_ID"
curl --netrc-file {{ base_dir }}/conf/search_index_elastic_access -X DELETE --header 'Content-Type: application/json' "http://{{ elasticsearch_host }}:{{ elasticsearch_port }}/_pit" -d "{\"id\": \"${PIT_ID}\"}"

createDiff() {
  date +"*** %Y-%m-%d %H:%M:%S creating diff file for last status minimum $1 days ago"
  LAST_ID_DUMP_FILE=$(find $TARGET_DIR -type f -name "{{ elasticsearch_metadata_index_alias_name }}_IDs.*" ! -name "{{ elasticsearch_metadata_index_alias_name }}_IDs.*.gz" -mtime "$1" -printf "%T@\t%p\n" | sort | tail -n 1 | cut -f 2-)
  if [[ $? != 0 ]]  || ! [[ $LAST_ID_DUMP_FILE ]]; then
    date +"*** %Y-%m-%d %H:%M:%S Found no existing ID dump"
  else
    DIFF_FILENAME="{{ elasticsearch_metadata_index_alias_name }}_DIFF_$2_$(echo $LAST_ID_DUMP_FILE | rev | cut -d "." -f 1 | rev)_${TIMESTAMP}"
    DIFF_FILE=${WORK_DIR}/${DIFF_FILENAME}
    date +"*** %Y-%m-%d %H:%M:%S determine content for diff file $DIFF_FILENAME"
    diff --new-line-format="+%L" --old-line-format="-%L" --unchanged-line-format="" <(sort $LAST_ID_DUMP_FILE) <(sort $ID_DUMP_FILE) > ${DIFF_FILE}
    date +"*** %Y-%m-%d %H:%M:%S finalizing diff file"
    gzip -fk ${DIFF_FILE}
    cp ${DIFF_FILE} $TARGET_DIR
    cp ${DIFF_FILE}.gz $TARGET_DIR
  fi
}
{% for diff_file_config in (search_index_dump_diff_file_configs | default([], true)) %}
createDiff "+{{ diff_file_config.min_time_in_days }}" "{{ diff_file_config.name }}"
{% endfor %}
date +"*** %Y-%m-%d %H:%M:%S cleanup diff files"
find $TARGET_DIR -type f -mtime +30 -name "{{ elasticsearch_metadata_index_alias_name }}_DIFF_*" -print0 | xargs -0r rm -vf
find $WORK_DIR -type f -mtime +30 -name "{{ elasticsearch_metadata_index_alias_name }}_DIFF_*" -print0 | xargs -0r rm -vf

date +"*** %Y-%m-%d %H:%M:%S finalizing dump file"
gzip -fk $DUMP_FILE
cp ${DUMP_FILE} $TARGET_DIR
cp ${DUMP_FILE}.gz $TARGET_DIR
gzip -fk $ID_DUMP_FILE
cp ${ID_DUMP_FILE} $TARGET_DIR
cp ${ID_DUMP_FILE}.gz $TARGET_DIR

date +"*** %Y-%m-%d %H:%M:%S cleanup dump files"
find $TARGET_DIR -type f -mtime +30 -name "{{ elasticsearch_metadata_index_alias_name }}_IDs.*" -print0 | xargs -0r rm -vf
find $WORK_DIR -type f -mtime +30 -name "{{ elasticsearch_metadata_index_alias_name }}_IDs.*" -print0 | xargs -0r rm -vf

date +"*** %Y-%m-%d %H:%M:%S done"
